// NetCache Resolver, 1995 (C) Mizutori Tetsuya
// - NCR_Qsort.h, October 18, 1995
// This document is pretty printed in 10-point Geneva font.

// definition

typedef struct {
	long	text;			// offset from the beginning of the handle
	long	textlen;
	long	keyword;		// offset from the beginning of the handle
	long	keywordlen;
} ArrayPair, *ArrayPairPtr, **ArrayPairHandle;

typedef struct {
	Handle	h;
	short		fs;		// field separator, as '\t'
	short		rs;		// record separator, as '\r'
	long		count;	// number of pair[]
	ArrayPair	pair[];
} Array, *ArrayPtr, **ArrayHandle;

// prototype
//void quicksort( Array *a, long left, long right );
void quicksort ( Array *a, long left, long right, Boolean asNumber, Boolean inReverse );

long SetupFieldArray ( Handle dataH, ArrayHandle arrayH, short keyPosition );

// end of definition
